/***************************************************************************
 *            gnc-account.c
 *
 *  mié ene 10 16:58:58 2007
 *  Copyright  2007  Daniel Espinosa Ortiz
 *  esodan@gmail.com
 ***************************************************************************/

/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#include "gnc-account.h"
#include "Account.h"
 
static void gnc_account_class_init(GncAccountClass *klass);
static void gnc_account_init(GncAccount *sp);
static void gnc_account_finalize(GObject *object);

struct _GncAccountPrivate {
	/* Private Members */
	Account *account;
};

typedef struct _GncAccountSignal GncAccountSignal;
typedef enum _GncAccountSignalType GncAccountSignalType;

enum _GncAccountSignalType {
	/* Signals Types */
	LAST_SIGNAL
};

struct _GncAccountSignal {
	GncAccount *object;
};

static guint gnc_account_signals[LAST_SIGNAL] = { 0 };
static GncObjectClass *parent_class = NULL;

GType
gnc_account_get_type ()
{
	static GType type = 0;

	if(type == 0) {
		static const GTypeInfo our_info = {
			sizeof (GncAccountClass),
			NULL,
			NULL,
			(GClassInitFunc)gnc_account_class_init,
			NULL,
			NULL,
			sizeof (GncAccount),
			0,
			(GInstanceInitFunc)gnc_account_init,
		};

		type = g_type_register_static(G_TYPE_OBJECT, 
			"GncAccount", &our_info, 0);
	}

	return type;
}

static void
gnc_account_class_init (GncAccountClass *klass)
{
	GObjectClass *object_class = G_OBJECT_CLASS(klass);

	parent_class = g_type_class_peek_parent(klass);
	object_class->finalize = gnc_account_finalize;
	
	/* Properties */
	
	/* Create signals:
	   gnc_account_signals[SIGNAL_TYPE_EXAMPLE] = g_signal_new(...)
 	*/
}

static void
gnc_account_init (GncAccount *obj)
{
	obj->priv = g_new0(GncAccountPrivate, 1);
	/* Initialize private members, etc. */
}

static void
gnc_account_finalize (GObject *object)
{
	GncAccount *cobj;
	cobj = GNC_ACCOUNT(object);
	
	/* Free private members, etc. */
		
	g_free(cobj->priv);
	G_OBJECT_CLASS(parent_class)->finalize(object);
}

GncAccount *
gnc_account_new ()
{
	GncAccount *obj;
	
	obj = GNC_ACCOUNT(g_object_new(GNC_TYPE_ACCOUNT, NULL));
	
	return obj;
}
