/***************************************************************************
 *            gnc-object.h
 *
 *  mié ene 10 12:23:52 2007
 *  Copyright  2007  Daniel Espinosa Ortiz
 *  esodan@gmail.com
 ***************************************************************************/

/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#ifndef GNC_OBJECT_H
#define GNC_OBJECT_H

#include <glib.h>
#include <glib-object.h>

G_BEGIN_DECLS

#define GNC_TYPE_OBJECT              (gnc_object_get_type ())
#define GNC_OBJECT(o)                   (G_TYPE_CHECK_INSTANCE_CAST ((o), GNC_TYPE_OBJECT, GncObject))
#define GNC_OBJECT_CLASS(k)        (G_TYPE_CHECK_CLASS_CAST((k), GNC_TYPE_OBJECT, GncObjectClass))
#define GNC_IS_OBJECT(o)               (G_TYPE_CHECK_INSTANCE_TYPE ((o), GNC_TYPE_OBJECT))
#define GNC_IS_OBJECT_CLASS(k)    (G_TYPE_CHECK_CLASS_TYPE ((k), GNC_TYPE_OBJECT))
#define GNC_OBJECT_GET_CLASS(o) (G_TYPE_INSTANCE_GET_CLASS ((o), GNC_TYPE_OBJECT, GncObjectClass))

/* General types */
#define GNC_TYPE_NUMERIC             (gnc_numeric_get_type())

#define GDA_VALUE_HOLDS_NUMERIC(value)          G_VALUE_HOLDS(value, GNC_TYPE_BINARY)

typedef gnc_numeric GncNumeric;

G_CONST_RETURN GdaBinary *gda_value_get_binary (const GValue *value);

/* GncObject Declarations */
typedef struct _GncObject GncObject;
typedef struct _GncObjectPrivate GncObjectPrivate;
typedef struct _GncObjectClass GncObjectClass;

struct _GncObject {
	GObject parent;
	GncObjectPrivate *priv;
};

struct _GncObjectClass {
	GObjectClass parent_class;
	/* virtual table */
	void                 (* set_qof_book)       (GncObject *object, QofBook *book);
	QofBook*          (* get_qof_book)       (GncObject *object);
	/* Add Signal Functions Here */
};

GType          gnc_object_get_type();
GncObject  *gnc_object_new();
void            gnc_object_set_qof_book (GncObject *object, QofBook *book);
QofBook     *gnc_object_get_qof_book (GncObject *object);



G_END_DECLS

#endif /* GNC_OBJECT_H */
