/***************************************************************************
 *            gnc-split.h
 *
 *  mié ene 10 14:10:55 2007
 *  Copyright  2007  Daniel Espinosa Ortiz
 *  esodan@gmail.com
 ***************************************************************************/

/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#ifndef GNC_SPLIT_H
#define GNC_SPLIT_H

#include <glib.h>
#include <glib-object.h>
#include "gnc-object.h"

G_BEGIN_DECLS

#define GNC_TYPE_SPLIT         (gnc_split_get_type ())
#define GNC_SPLIT(o)           (G_TYPE_CHECK_INSTANCE_CAST ((o), GNC_TYPE_SPLIT, GncSplit))
#define GNC_SPLIT_CLASS(k)     (G_TYPE_CHECK_CLASS_CAST((k), GNC_TYPE_SPLIT, GncSplitClass))
#define GNC_IS_SPLIT(o)        (G_TYPE_CHECK_INSTANCE_TYPE ((o), GNC_TYPE_SPLIT))
#define GNC_IS_SPLIT_CLASS(k)  (G_TYPE_CHECK_CLASS_TYPE ((k), GNC_TYPE_SPLIT))
#define GNC_SPLIT_GET_CLASS(o) (G_TYPE_INSTANCE_GET_CLASS ((o), GNC_TYPE_SPLIT, GncSplitClass))

typedef struct _GncSplit GncSplit;
typedef struct _GncSplitPrivate GncSplitPrivate;
typedef struct _GncSplitClass GncSplitClass;

struct _GncSplit {
	GncObject parent;
	GncSplitPrivate *priv;
};

struct _GncSplitClass {
	GncObjectClass parent_class;
	/* Add Signal Functions Here */
};

GType                  gnc_split_get_type();
GncSplit             *gnc_split_new (QofBook *book);

gboolean             gnc_split_delete (GncSplit *split);

void                    gnc_split_set_account (GncSplit *split, GncAccount *account);
GncAccount        *gnc_split_get_account (GncSplit *split);

GncNumeric         gnc_split_convert_amount (const GncSplit *split, GncAccount * account);

G_END_DECLS

#endif /* GNC_SPLIT_H */
